# String

Source:
  - constructors/extensions/prototype.js, line 1427

### Methods

#### add_Class(className) → {string}

Source:
  - constructors/extensions/prototype.js, line 1500

##### Parameters:

Name | Type | Description
--- | --- | ---
`className` | string |

##### Returns:

Type
  string

#### add_Class(newClass) → {string}

Source:
  - dictionary.d.js, line 785

##### Parameters:

Name | Type | Description
--- | --- | ---
`newClass` | string |

##### Returns:

Type
  string

#### base64decode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1808

##### Returns:

Type
  string

#### base64decode() → {string}

Source:
  - dictionary.d.js, line 888

##### Returns:

Type
  string

#### base64decodeBytes() → {Uint8Array}

Source:
  - constructors/extensions/prototype.js, line 1826

##### Returns:

Type
  Uint8Array

#### base64decodeBytes() → {Uint8Array}

Source:
  - dictionary.d.js, line 900

##### Returns:

Type
  Uint8Array

#### base64decodeBytesArray() → {Array.<number>}

Source:
  - constructors/extensions/prototype.js, line 1832

##### Returns:

Type
  Array.<number>

#### base64decodeBytesArray() → {Array.<number>}

Source:
  - dictionary.d.js, line 912

##### Returns:

Type
  Array.<number>

#### base64decodeClean() → {string}

Source:
  - constructors/extensions/prototype.js, line 1844

##### Returns:

Type
  string

#### base64decodeClean() → {string}

Source:
  - dictionary.d.js, line 931

##### Returns:

Type
  string

#### base64encode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1802

##### Returns:

Type
  string

#### base64encode() → {string}

Source:
  - dictionary.d.js, line 894

##### Returns:

Type
  string

#### base64encodeBytes() → {Uint8Array}

Source:
  - constructors/extensions/prototype.js, line 1814

##### Returns:

Type
  Uint8Array

#### base64encodeBytes() → {Uint8Array}

Source:
  - dictionary.d.js, line 906

##### Returns:

Type
  Uint8Array

#### base64encodeBytesArray() → {Array.<number>}

Source:
  - constructors/extensions/prototype.js, line 1820

##### Returns:

Type
  Array.<number>

#### base64encodeBytesArray() → {Array.<number>}

Source:
  - dictionary.d.js, line 918

##### Returns:

Type
  Array.<number>

#### base64encodeClean() → {string}

Source:
  - constructors/extensions/prototype.js, line 1838

##### Returns:

Type
  string

#### base64encodeClean() → {string}

Source:
  - dictionary.d.js, line 925

##### Returns:

Type
  string

#### buildQuery() → {Object.<string, string>}

Source:
  - constructors/extensions/prototype.js, line 1880

"asd asdsdf param:sdd test:data 2 info".buildQuery() {keys: ["", "param", "test"], _: 'asd asdsdf', param: 'sdd', test: 'data 2 info'}

##### Returns:

Type
  Object.<string, string>

#### buildQuery() → {Object.<string, (string|Array.<string>)>}

Source:
  - dictionary.d.js, line 1022

Returns a list of parameters included in a string

##### Example

    'my-demo testIndex: 23 with testValue: "demo content"'.buildQuery()
    // returns
    {
        "_keys": [
            "testindex",
            "testvalue"
        ],
        "_": "my-demo",
        "testindex": "23 with",
        "testvalue": "\"demo content\""
    }

##### Returns:

Type
  Object.<string, (string|Array.<string>)>

#### buildSearchArray() → {Array.<string>}

Source:
  - constructors/extensions/prototype.js, line 1902

"23 test "composed param" 234".buildSearchArray() ['23', 'test', 'composed param', '234']

##### Returns:

Type
  Array.<string>

#### buildSearchArray() → {Array.<string>}

Source:
  - dictionary.d.js, line 1042

Returns a list of parameters included in a string

##### Example

    '"this is" "list of fragments"'.buildSearchArray()
    // returns
    [
        "this is",
        "list of fragments"
    ]

##### Returns:

Type
  Array.<string>

#### cleanTags() → {string}

Source:
  - constructors/extensions/prototype.js, line 1491

remove dangerous HTML Tags

##### Returns:

Type
  string

#### cleanTags() → {string}

Source:
  - dictionary.d.js, line 778

remove risky tags from HTML Code: comments, script, iframe, style, object, noscript, frame, frameset

##### Returns:

Type
  string

#### decodeURI() → {string}

Source:
  - constructors/extensions/prototype.js, line 1639

##### Returns:

Type
  string

#### decodeURI() → {string}

Source:
  - dictionary.d.js, line 943

##### Returns:

Type
  string

#### decryptAes(password, bytesopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1872

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`password` | string |  |  |
`bytes` | 128 | 256 | 512 | <optional> | `128` |

##### Returns:

Type
  string

#### decryptAes(password, sizeopt) → {string}

Source:
  - dictionary.d.js, line 866

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`password` | string |  |  |
`size` | number | <optional> | `128` |

##### Returns:

Type
  string

#### decryptTea(password) → {string}

Source:
  - constructors/extensions/prototype.js, line 1857

##### Parameters:

Name | Type | Description
--- | --- | ---
`password` | string |

##### Returns:

Type
  string

#### decryptTea(password) → {string}

Source:
  - dictionary.d.js, line 881

##### Parameters:

Name | Type | Description
--- | --- | ---
`password` | string |

##### Returns:

Type
  string

#### del_Class(className) → {string}

Source:
  - constructors/extensions/prototype.js, line 1519

##### Parameters:

Name | Type | Description
--- | --- | ---
`className` | string |

##### Returns:

Type
  string

#### del_Class(newClass) → {string}

Source:
  - dictionary.d.js, line 792

##### Parameters:

Name | Type | Description
--- | --- | ---
`newClass` | string |

##### Returns:

Type
  string

#### encodeURI() → {string}

Source:
  - constructors/extensions/prototype.js, line 1627

##### Returns:

Type
  string

#### encodeURI() → {string}

Source:
  - dictionary.d.js, line 937

##### Returns:

Type
  string

#### encryptAes(password, bytesopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1864

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`password` | string |  |  |
`bytes` | 128 | 256 | 512 | <optional> | `128` |

##### Returns:

Type
  string

#### encryptAes(password, sizeopt) → {string}

Source:
  - dictionary.d.js, line 859

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`password` | string |  |  |
`size` | number | <optional> | `128` |

##### Returns:

Type
  string

#### encryptTea(password) → {string}

Source:
  - constructors/extensions/prototype.js, line 1850

##### Parameters:

Name | Type | Description
--- | --- | ---
`password` | string |

##### Returns:

Type
  string

#### encryptTea(password) → {string}

Source:
  - dictionary.d.js, line 874

##### Parameters:

Name | Type | Description
--- | --- | ---
`password` | string |

##### Returns:

Type
  string

#### escape() → {string}

Source:
  - constructors/extensions/prototype.js, line 1621

##### Returns:

Type
  string

#### escape() → {string}

Source:
  - dictionary.d.js, line 955

##### Returns:

Type
  string

#### escapeHex() → {string}

Source:
  - constructors/extensions/prototype.js, line 1615

##### Returns:

Type
  string

#### escapeHex() → {string}

Source:
  - dictionary.d.js, line 949

##### Returns:

Type
  string

#### fnd_Class(className) → {boolean}

Source:
  - constructors/extensions/prototype.js, line 1533

find a class

##### Parameters:

Name | Type | Description
--- | --- | ---
`className` | string |

##### Returns:

Type
  boolean

#### fnd_Class(newClass) → {boolean}

Source:
  - dictionary.d.js, line 799

##### Parameters:

Name | Type | Description
--- | --- | ---
`newClass` | string |

##### Returns:

Type
  boolean

#### fromHex() → {string}

Source:
  - constructors/extensions/prototype.js, line 1467

##### Returns:

Type
  string

#### fromHex() → {string}

Source:
  - dictionary.d.js, line 751

##### Returns:

Type
  string

#### fromHtml() → {string}

Source:
  - constructors/extensions/prototype.js, line 1485

##### Returns:

Type
  string

#### fromHtml() → {string}

Source:
  - dictionary.d.js, line 771

decode from HTML ( works in Browser )

##### Returns:

Type
  string

#### lcfirst(kopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1565

lowercase first [k] letters from word

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`k` | number | <optional> | `1` |

##### Returns:

Type
  string

#### lcfirst(lengthopt) → {string}

Source:
  - dictionary.d.js, line 819

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`length` | number | <optional> | `1` | how many first chars to be transformed to uppercase

##### Returns:

Type
  string

#### markdown() → {string}

Source:
  - dictionary.d.js, line 995

##### Returns:

Type
  string

#### match_str(reg_exp, flagsopt) → {Array.<string>|null}

Source:
  - constructors/extensions/prototype.js, line 1774

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`reg_exp` | string |  |
`flags` | string | <optional> |

##### Returns:

Type
  Array.<string> | null

#### match_str(rule, flagsopt) → {Array|object}

Source:
  - dictionary.d.js, line 1014

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`rule` | string |  | reg exp rule in string format
`flags` | string | <optional> | reg exp flags

##### Returns:

Type
  Array | object

#### md5() → {string}

Source:
  - constructors/extensions/prototype.js, line 1796

##### Returns:

Type
  string

#### md5() → {string}

Source:
  - dictionary.d.js, line 989

##### Returns:

Type
  string

#### parseUrl(kopt) → {String.String_parseUrl_return}

Source:
  - constructors/extensions/prototype.js, line 1741

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`k` | boolean | <optional> | `false` | decode get vars

##### Returns:

Type
  String.String_parseUrl_return

#### parseUrl(modeopt) → {object}

Source:
  - dictionary.d.js, line 1007

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`mode` | "get_vars" | boolean | <optional> |

##### Returns:

Type
  object

#### parseUrlVars(jsonopt, paramsopt) → {Object.<string, any>}

Source:
  - constructors/extensions/prototype.js, line 1645

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`json` | boolean | <optional> | `false` |
`params` | object | <optional> |  | ###### Properties
Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`keepOBJ` | boolean | <optional> | `false` |
`isURL` | boolean | <optional> | `false` |

##### Returns:

Type
  Object.<string, any>

#### sha1() → {string}

Source:
  - constructors/extensions/prototype.js, line 1784

##### Returns:

Type
  string

#### sha1(isUtf8opt) → {string}

Source:
  - dictionary.d.js, line 967

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`isUtf8` | boolean | <optional> | `true` |

##### Returns:

Type
  string

#### sha256() → {string}

Source:
  - constructors/extensions/prototype.js, line 1790

##### Returns:

Type
  string

#### sha256(isUtf8opt) → {string}

Source:
  - dictionary.d.js, line 974

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`isUtf8` | boolean | <optional> | `true` |

##### Returns:

Type
  string

#### subs(p, iopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1431

similar as PHP subs

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`p` | number |  |
`i` | number | <optional> |

##### Returns:

Type
  string

#### subs(index, lastIndexopt) → {string}

Source:
  - dictionary.d.js, line 736

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`index` | number |  |
`lastIndex` | number | <optional> |

##### Returns:

Type
  string

#### subs(index, count) → {string}

Source:
  - dictionary.d.js, line 981

##### Parameters:

Name | Type | Description
--- | --- | ---
`index` | number |
`count` | number |

##### Returns:

Type
  string

#### swp_case() → {string}

Source:
  - constructors/extensions/prototype.js, line 1550

swap letters' case

##### Returns:

Type
  string

#### swp_case() → {string}

Source:
  - dictionary.d.js, line 806

##### Returns:

Type
  string

#### toArrayBufferFromUtf8() → {ArrayBuffer}

Source:
  - constructors/extensions/prototype.js, line 1932

##### Returns:

Type
  ArrayBuffer

#### toArrayBufferFromUtf8() → {ArrayBuffer}

Source:
  - dictionary.d.js, line 1056

##### Returns:

Type
  ArrayBuffer

#### toHex(utf8) → {string}

Source:
  - constructors/extensions/prototype.js, line 1445

##### Parameters:

Name | Type | Description
--- | --- | ---
`utf8` | boolean |

##### Returns:

Type
  string

#### toHex(isUtf8opt) → {string}

Source:
  - dictionary.d.js, line 744

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`isUtf8` | boolean | <optional> | `true` |

##### Returns:

Type
  string

#### toHtml() → {string}

Source:
  - constructors/extensions/prototype.js, line 1479

##### Returns:

Type
  string

#### toHtml() → {string}

Source:
  - dictionary.d.js, line 764

encode in HTML

##### Returns:

Type
  string

#### toHtmlSimple() → {string}

Source:
  - constructors/extensions/prototype.js, line 1473

##### Returns:

Type
  string

#### toHtmlSimple() → {string}

Source:
  - dictionary.d.js, line 757

encode in HTML minimal

##### Returns:

Type
  string

#### toRegexp(flagsopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1602

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`flags` | string | <optional> |

##### Returns:

Type
  string

#### toRegexp() → {RegExp}

Source:
  - dictionary.d.js, line 1001

##### Returns:

Type
  RegExp

#### ucfirst(kopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1557

uppercase first [k] letters from word

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`k` | number | <optional> | `1` |

##### Returns:

Type
  string

#### ucfirst(lengthopt) → {string}

Source:
  - dictionary.d.js, line 812

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`length` | number | <optional> | `1` | how many first chars to be transformed to uppercase

##### Returns:

Type
  string

#### unescape() → {string}

Source:
  - constructors/extensions/prototype.js, line 1633

##### Returns:

Type
  string

#### unescape() → {string}

Source:
  - dictionary.d.js, line 961

##### Returns:

Type
  string

#### unicode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1925

similar as utf8decode

##### Returns:

Type
  string

#### unicode() → {string}

Source:
  - dictionary.d.js, line 852
See:
  - {String#utf8decode}

##### Returns:

Type
  string

#### utf8() → {string}

Source:
  - constructors/extensions/prototype.js, line 1918

similar as utf8encode

##### Returns:

Type
  string

#### utf8() → {string}

Source:
  - dictionary.d.js, line 845
See:
  - {String#utf8encode}

##### Returns:

Type
  string

#### utf8decode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1592

##### Returns:

Type
  string

#### utf8decode() → {string}

Source:
  - dictionary.d.js, line 839

##### Returns:

Type
  string

#### utf8encode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1582

##### Returns:

Type
  string

#### utf8encode() → {string}

Source:
  - dictionary.d.js, line 833

##### Returns:

Type
  string

#### utf8need() → {string}

Source:
  - constructors/extensions/prototype.js, line 1573

##### Returns:

Type
  string

#### utf8need() → {string}

Source:
  - dictionary.d.js, line 826

Detects if a string is unicode, and if it is, then it is transformed to UTF8

##### Returns:

Type
  string

### Type Definitions

#### String_parseUrl_return

Source:
  - constructors/extensions/prototype.js, line 1725

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`original` | string |  | https://www.test.example.com/path/data?request=5#search
`origin` | string |  | www.test.example.com
`domain` | string |  | www.test.example.com
`domain_short` | string |  | test.example.com
`pathname` | string |  | /path/data
`reqQuery` | string |  | request=5
`protocol` | string |  | https
`protocoll` | string |  | https://
`get_vars` | Object.<string, any> | <optional> |
`url` | string |  | deprecated
`url_p` | string |  | deprecated
`isIp` | string |  | deprecated

##### Type:

- object

## String

Source:
  - dictionary.d.js, line 732

### Methods

#### add_Class(className) → {string}

Source:
  - constructors/extensions/prototype.js, line 1500

##### Parameters:

Name | Type | Description
--- | --- | ---
`className` | string |

##### Returns:

Type
  string

#### add_Class(newClass) → {string}

Source:
  - dictionary.d.js, line 785

##### Parameters:

Name | Type | Description
--- | --- | ---
`newClass` | string |

##### Returns:

Type
  string

#### base64decode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1808

##### Returns:

Type
  string

#### base64decode() → {string}

Source:
  - dictionary.d.js, line 888

##### Returns:

Type
  string

#### base64decodeBytes() → {Uint8Array}

Source:
  - constructors/extensions/prototype.js, line 1826

##### Returns:

Type
  Uint8Array

#### base64decodeBytes() → {Uint8Array}

Source:
  - dictionary.d.js, line 900

##### Returns:

Type
  Uint8Array

#### base64decodeBytesArray() → {Array.<number>}

Source:
  - constructors/extensions/prototype.js, line 1832

##### Returns:

Type
  Array.<number>

#### base64decodeBytesArray() → {Array.<number>}

Source:
  - dictionary.d.js, line 912

##### Returns:

Type
  Array.<number>

#### base64decodeClean() → {string}

Source:
  - constructors/extensions/prototype.js, line 1844

##### Returns:

Type
  string

#### base64decodeClean() → {string}

Source:
  - dictionary.d.js, line 931

##### Returns:

Type
  string

#### base64encode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1802

##### Returns:

Type
  string

#### base64encode() → {string}

Source:
  - dictionary.d.js, line 894

##### Returns:

Type
  string

#### base64encodeBytes() → {Uint8Array}

Source:
  - constructors/extensions/prototype.js, line 1814

##### Returns:

Type
  Uint8Array

#### base64encodeBytes() → {Uint8Array}

Source:
  - dictionary.d.js, line 906

##### Returns:

Type
  Uint8Array

#### base64encodeBytesArray() → {Array.<number>}

Source:
  - constructors/extensions/prototype.js, line 1820

##### Returns:

Type
  Array.<number>

#### base64encodeBytesArray() → {Array.<number>}

Source:
  - dictionary.d.js, line 918

##### Returns:

Type
  Array.<number>

#### base64encodeClean() → {string}

Source:
  - constructors/extensions/prototype.js, line 1838

##### Returns:

Type
  string

#### base64encodeClean() → {string}

Source:
  - dictionary.d.js, line 925

##### Returns:

Type
  string

#### buildQuery() → {Object.<string, string>}

Source:
  - constructors/extensions/prototype.js, line 1880

"asd asdsdf param:sdd test:data 2 info".buildQuery() {keys: ["", "param", "test"], _: 'asd asdsdf', param: 'sdd', test: 'data 2 info'}

##### Returns:

Type
  Object.<string, string>

#### buildQuery() → {Object.<string, (string|Array.<string>)>}

Source:
  - dictionary.d.js, line 1022

Returns a list of parameters included in a string

##### Example

    'my-demo testIndex: 23 with testValue: "demo content"'.buildQuery()
    // returns
    {
        "_keys": [
            "testindex",
            "testvalue"
        ],
        "_": "my-demo",
        "testindex": "23 with",
        "testvalue": "\"demo content\""
    }

##### Returns:

Type
  Object.<string, (string|Array.<string>)>

#### buildSearchArray() → {Array.<string>}

Source:
  - constructors/extensions/prototype.js, line 1902

"23 test "composed param" 234".buildSearchArray() ['23', 'test', 'composed param', '234']

##### Returns:

Type
  Array.<string>

#### buildSearchArray() → {Array.<string>}

Source:
  - dictionary.d.js, line 1042

Returns a list of parameters included in a string

##### Example

    '"this is" "list of fragments"'.buildSearchArray()
    // returns
    [
        "this is",
        "list of fragments"
    ]

##### Returns:

Type
  Array.<string>

#### cleanTags() → {string}

Source:
  - constructors/extensions/prototype.js, line 1491

remove dangerous HTML Tags

##### Returns:

Type
  string

#### cleanTags() → {string}

Source:
  - dictionary.d.js, line 778

remove risky tags from HTML Code: comments, script, iframe, style, object, noscript, frame, frameset

##### Returns:

Type
  string

#### decodeURI() → {string}

Source:
  - constructors/extensions/prototype.js, line 1639

##### Returns:

Type
  string

#### decodeURI() → {string}

Source:
  - dictionary.d.js, line 943

##### Returns:

Type
  string

#### decryptAes(password, bytesopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1872

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`password` | string |  |  |
`bytes` | 128 | 256 | 512 | <optional> | `128` |

##### Returns:

Type
  string

#### decryptAes(password, sizeopt) → {string}

Source:
  - dictionary.d.js, line 866

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`password` | string |  |  |
`size` | number | <optional> | `128` |

##### Returns:

Type
  string

#### decryptTea(password) → {string}

Source:
  - constructors/extensions/prototype.js, line 1857

##### Parameters:

Name | Type | Description
--- | --- | ---
`password` | string |

##### Returns:

Type
  string

#### decryptTea(password) → {string}

Source:
  - dictionary.d.js, line 881

##### Parameters:

Name | Type | Description
--- | --- | ---
`password` | string |

##### Returns:

Type
  string

#### del_Class(className) → {string}

Source:
  - constructors/extensions/prototype.js, line 1519

##### Parameters:

Name | Type | Description
--- | --- | ---
`className` | string |

##### Returns:

Type
  string

#### del_Class(newClass) → {string}

Source:
  - dictionary.d.js, line 792

##### Parameters:

Name | Type | Description
--- | --- | ---
`newClass` | string |

##### Returns:

Type
  string

#### encodeURI() → {string}

Source:
  - constructors/extensions/prototype.js, line 1627

##### Returns:

Type
  string

#### encodeURI() → {string}

Source:
  - dictionary.d.js, line 937

##### Returns:

Type
  string

#### encryptAes(password, bytesopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1864

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`password` | string |  |  |
`bytes` | 128 | 256 | 512 | <optional> | `128` |

##### Returns:

Type
  string

#### encryptAes(password, sizeopt) → {string}

Source:
  - dictionary.d.js, line 859

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`password` | string |  |  |
`size` | number | <optional> | `128` |

##### Returns:

Type
  string

#### encryptTea(password) → {string}

Source:
  - constructors/extensions/prototype.js, line 1850

##### Parameters:

Name | Type | Description
--- | --- | ---
`password` | string |

##### Returns:

Type
  string

#### encryptTea(password) → {string}

Source:
  - dictionary.d.js, line 874

##### Parameters:

Name | Type | Description
--- | --- | ---
`password` | string |

##### Returns:

Type
  string

#### escape() → {string}

Source:
  - constructors/extensions/prototype.js, line 1621

##### Returns:

Type
  string

#### escape() → {string}

Source:
  - dictionary.d.js, line 955

##### Returns:

Type
  string

#### escapeHex() → {string}

Source:
  - constructors/extensions/prototype.js, line 1615

##### Returns:

Type
  string

#### escapeHex() → {string}

Source:
  - dictionary.d.js, line 949

##### Returns:

Type
  string

#### fnd_Class(className) → {boolean}

Source:
  - constructors/extensions/prototype.js, line 1533

find a class

##### Parameters:

Name | Type | Description
--- | --- | ---
`className` | string |

##### Returns:

Type
  boolean

#### fnd_Class(newClass) → {boolean}

Source:
  - dictionary.d.js, line 799

##### Parameters:

Name | Type | Description
--- | --- | ---
`newClass` | string |

##### Returns:

Type
  boolean

#### fromHex() → {string}

Source:
  - constructors/extensions/prototype.js, line 1467

##### Returns:

Type
  string

#### fromHex() → {string}

Source:
  - dictionary.d.js, line 751

##### Returns:

Type
  string

#### fromHtml() → {string}

Source:
  - constructors/extensions/prototype.js, line 1485

##### Returns:

Type
  string

#### fromHtml() → {string}

Source:
  - dictionary.d.js, line 771

decode from HTML ( works in Browser )

##### Returns:

Type
  string

#### lcfirst(kopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1565

lowercase first [k] letters from word

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`k` | number | <optional> | `1` |

##### Returns:

Type
  string

#### lcfirst(lengthopt) → {string}

Source:
  - dictionary.d.js, line 819

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`length` | number | <optional> | `1` | how many first chars to be transformed to uppercase

##### Returns:

Type
  string

#### markdown() → {string}

Source:
  - dictionary.d.js, line 995

##### Returns:

Type
  string

#### match_str(reg_exp, flagsopt) → {Array.<string>|null}

Source:
  - constructors/extensions/prototype.js, line 1774

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`reg_exp` | string |  |
`flags` | string | <optional> |

##### Returns:

Type
  Array.<string> | null

#### match_str(rule, flagsopt) → {Array|object}

Source:
  - dictionary.d.js, line 1014

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`rule` | string |  | reg exp rule in string format
`flags` | string | <optional> | reg exp flags

##### Returns:

Type
  Array | object

#### md5() → {string}

Source:
  - constructors/extensions/prototype.js, line 1796

##### Returns:

Type
  string

#### md5() → {string}

Source:
  - dictionary.d.js, line 989

##### Returns:

Type
  string

#### parseUrl(kopt) → {String.String_parseUrl_return}

Source:
  - constructors/extensions/prototype.js, line 1741

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`k` | boolean | <optional> | `false` | decode get vars

##### Returns:

Type
  String.String_parseUrl_return

#### parseUrl(modeopt) → {object}

Source:
  - dictionary.d.js, line 1007

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`mode` | "get_vars" | boolean | <optional> |

##### Returns:

Type
  object

#### parseUrlVars(jsonopt, paramsopt) → {Object.<string, any>}

Source:
  - constructors/extensions/prototype.js, line 1645

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`json` | boolean | <optional> | `false` |
`params` | object | <optional> |  | ###### Properties
Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`keepOBJ` | boolean | <optional> | `false` |
`isURL` | boolean | <optional> | `false` |

##### Returns:

Type
  Object.<string, any>

#### sha1() → {string}

Source:
  - constructors/extensions/prototype.js, line 1784

##### Returns:

Type
  string

#### sha1(isUtf8opt) → {string}

Source:
  - dictionary.d.js, line 967

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`isUtf8` | boolean | <optional> | `true` |

##### Returns:

Type
  string

#### sha256() → {string}

Source:
  - constructors/extensions/prototype.js, line 1790

##### Returns:

Type
  string

#### sha256(isUtf8opt) → {string}

Source:
  - dictionary.d.js, line 974

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`isUtf8` | boolean | <optional> | `true` |

##### Returns:

Type
  string

#### subs(p, iopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1431

similar as PHP subs

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`p` | number |  |
`i` | number | <optional> |

##### Returns:

Type
  string

#### subs(index, lastIndexopt) → {string}

Source:
  - dictionary.d.js, line 736

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`index` | number |  |
`lastIndex` | number | <optional> |

##### Returns:

Type
  string

#### subs(index, count) → {string}

Source:
  - dictionary.d.js, line 981

##### Parameters:

Name | Type | Description
--- | --- | ---
`index` | number |
`count` | number |

##### Returns:

Type
  string

#### swp_case() → {string}

Source:
  - constructors/extensions/prototype.js, line 1550

swap letters' case

##### Returns:

Type
  string

#### swp_case() → {string}

Source:
  - dictionary.d.js, line 806

##### Returns:

Type
  string

#### toArrayBufferFromUtf8() → {ArrayBuffer}

Source:
  - constructors/extensions/prototype.js, line 1932

##### Returns:

Type
  ArrayBuffer

#### toArrayBufferFromUtf8() → {ArrayBuffer}

Source:
  - dictionary.d.js, line 1056

##### Returns:

Type
  ArrayBuffer

#### toHex(utf8) → {string}

Source:
  - constructors/extensions/prototype.js, line 1445

##### Parameters:

Name | Type | Description
--- | --- | ---
`utf8` | boolean |

##### Returns:

Type
  string

#### toHex(isUtf8opt) → {string}

Source:
  - dictionary.d.js, line 744

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`isUtf8` | boolean | <optional> | `true` |

##### Returns:

Type
  string

#### toHtml() → {string}

Source:
  - constructors/extensions/prototype.js, line 1479

##### Returns:

Type
  string

#### toHtml() → {string}

Source:
  - dictionary.d.js, line 764

encode in HTML

##### Returns:

Type
  string

#### toHtmlSimple() → {string}

Source:
  - constructors/extensions/prototype.js, line 1473

##### Returns:

Type
  string

#### toHtmlSimple() → {string}

Source:
  - dictionary.d.js, line 757

encode in HTML minimal

##### Returns:

Type
  string

#### toRegexp(flagsopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1602

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`flags` | string | <optional> |

##### Returns:

Type
  string

#### toRegexp() → {RegExp}

Source:
  - dictionary.d.js, line 1001

##### Returns:

Type
  RegExp

#### ucfirst(kopt) → {string}

Source:
  - constructors/extensions/prototype.js, line 1557

uppercase first [k] letters from word

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`k` | number | <optional> | `1` |

##### Returns:

Type
  string

#### ucfirst(lengthopt) → {string}

Source:
  - dictionary.d.js, line 812

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`length` | number | <optional> | `1` | how many first chars to be transformed to uppercase

##### Returns:

Type
  string

#### unescape() → {string}

Source:
  - constructors/extensions/prototype.js, line 1633

##### Returns:

Type
  string

#### unescape() → {string}

Source:
  - dictionary.d.js, line 961

##### Returns:

Type
  string

#### unicode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1925

similar as utf8decode

##### Returns:

Type
  string

#### unicode() → {string}

Source:
  - dictionary.d.js, line 852
See:
  - {String#utf8decode}

##### Returns:

Type
  string

#### utf8() → {string}

Source:
  - constructors/extensions/prototype.js, line 1918

similar as utf8encode

##### Returns:

Type
  string

#### utf8() → {string}

Source:
  - dictionary.d.js, line 845
See:
  - {String#utf8encode}

##### Returns:

Type
  string

#### utf8decode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1592

##### Returns:

Type
  string

#### utf8decode() → {string}

Source:
  - dictionary.d.js, line 839

##### Returns:

Type
  string

#### utf8encode() → {string}

Source:
  - constructors/extensions/prototype.js, line 1582

##### Returns:

Type
  string

#### utf8encode() → {string}

Source:
  - dictionary.d.js, line 833

##### Returns:

Type
  string

#### utf8need() → {string}

Source:
  - constructors/extensions/prototype.js, line 1573

##### Returns:

Type
  string

#### utf8need() → {string}

Source:
  - dictionary.d.js, line 826

Detects if a string is unicode, and if it is, then it is transformed to UTF8

##### Returns:

Type
  string

### Type Definitions

#### String_parseUrl_return

Source:
  - constructors/extensions/prototype.js, line 1725

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`original` | string |  | https://www.test.example.com/path/data?request=5#search
`origin` | string |  | www.test.example.com
`domain` | string |  | www.test.example.com
`domain_short` | string |  | test.example.com
`pathname` | string |  | /path/data
`reqQuery` | string |  | request=5
`protocol` | string |  | https
`protocoll` | string |  | https://
`get_vars` | Object.<string, any> | <optional> |
`url` | string |  | deprecated
`url_p` | string |  | deprecated
`isIp` | string |  | deprecated

##### Type:

- object